import { errorMapper } from "./modules/errorMapping";
import { BigHarvest, Harvest } from "./modules/harvester";
import { Build } from "./modules/builder";
import { Upgrade } from "./modules/upgrader";
import { SpawnCreep } from "./modules/spawnCreep";
import { RoleToString, UpdateGlobalMemory } from "./modules/creepApi";
import { Role } from "./modules/setting";
export const loop = errorMapper(() => {
    let mainSpawn = Game.spawns["Spawn1"];
    SpawnCreep(mainSpawn);
    UpdateGlobalMemory();

    for (var name in Game.creeps) {
        let creep = Game.creeps[name];
        if (creep.memory.role == RoleToString(Role.Harvester)) {
            Harvest(creep);
        } else if (creep.memory.role == RoleToString(Role.Upgrader)) {
            Upgrade(creep);
        } else if (creep.memory.role == RoleToString(Role.Builder)) {
            Build(creep);
        }else if(creep.memory.role == RoleToString(Role.BigHarvester)){
            BigHarvest(creep);
        }
    }
})